# PAIC Patterns

Principled AI Coding Patterns for large-scale, max-compute, low-error engineering in the GenAI Age.

> **WARNING:** Do not install using pip. This is a private, members-only tool. You will not have access. See [this link](https://agenticengineer.com/principled-ai-coding) to gain access.

![PAIC Patterns](https://firebasestorage.googleapis.com/v0/b/agentic-engineer.appspot.com/o/paicc%2Fpublic-images%2Fpaic-patterns-members-only.jpg?alt=media&token=94b4d1b6-3d5c-4163-93d3-81e6835629b9)

## What is PAIC Patterns?

### AI Coding at Scale
PAIC Patterns is a light weight, plan based AI Coding tool that's designed to SCALE YOUR IMPACT with LARGE SCALE, FULL FEATURE, PRECISE AI Coding. This bonus, members only, tool embeds the principles you've learned in the Principled AI Coding course into a suite of easy to use patterns.

### Scale Your Compute - Scale Your Impact
Most AI Coding tools are limited by their 'one prompt at a time', iterative approach. PAIC Patterns let's you scale your compute, and scale your impact by giving you patterns to run not just one prompt at a time, but 2, 5, 10, 20+ prompts in one shot. Here's how it works:

1. (CREATE) Create a new spec
2. (PLAN) Update the spec with the BIG THREE: Context, Model and Prompt(s) to detail the feature you want to build
3. (EXECUTE) Execute your spec in a single shot and watch as your AI Coding Assistant scales your impact across your entire codebase

### Built on Principled AI Coding
Every feature in PAIC Patterns is built on the core principles you've learned in this course:

* **KISS** - Keep your work simple and focused on clear outcomes through clear plans

* **BIG THREE BULLSEYE** - Align your Context, Model and Prompt(s) for concise, precise and repeatable results

* **Use IDKs** - Using specific, powerful keywords in your prompts to generate precise results again and again and again

* **Great Planning is Great Prompting** - Separation of planning and execution through detailed specs

* **Leverage ADWs** - Create reusable AI Developer Workflows and reusable planning assets to solve the same class of problems once and for all

* **Closed Loop Systems** - Use concrete execution commands and feedback loops to 'let the code write itself'

* **Scale your Compute - Scale your Impact** - Hit the sweet spot between lists of low, medium, and high level prompts and run 2, 5, 10, 20+ (not an exaggeration) prompts in one shot

These principles aren't just theory - they're baked into the tool's architecture, so you can effortlessly apply what you've learned in PAIC at scale with MINIMUM effort.


## Principled AI Coding Members only tool for Scaled AI Coding
> This is a members only tool. Visit [Principled AI Coding](https://agenticengineer.com/principled-ai-coding) to learn more.
